import React from 'react';
import {AppRegistry, useColorScheme} from 'react-native';
import {NavigationContainer} from '@react-navigation/native';
import {createNativeStackNavigator} from '@react-navigation/native-stack';
import {Colors} from 'react-native/Libraries/NewAppScreen';

import {name as appName} from './app.json';
import WelcomeScreen from './Screens/WelcomeScreen';
import PaymentScreen from './Screens/PaymentScreen';

const Stack = createNativeStackNavigator();

const PayAsYouGo = React.memo(props => {
  const isDarkMode = useColorScheme() === 'dark';
  const screenOptions = () => ({
    unmountOnBlur: true,
    headerStyle: {
      backgroundColor: isDarkMode ? Colors.darker : Colors.lighter,
    },
    headerShadowVisible: false,
    headerTintColor: isDarkMode ? Colors.lighter : Colors.darker,
  });

  return (
    <NavigationContainer independent={true}>
      <Stack.Navigator>
        <Stack.Screen name="Welcome" options={screenOptions}>
          {screenProps => <WelcomeScreen {...props} {...screenProps} />}
        </Stack.Screen>
        <Stack.Screen name="Payment" options={screenOptions}>
          {screenProps => <PaymentScreen {...props} {...screenProps} />}
        </Stack.Screen>
      </Stack.Navigator>
    </NavigationContainer>
  );
});

if (__DEV__) {
  AppRegistry.registerComponent(appName, () => PayAsYouGo);
}
export default PayAsYouGo;
